//
// Created by webpigeon on 29/12/22.
//

#ifndef COMP290_WORKSHEETS_LAB1_HPP
#define COMP290_WORKSHEETS_LAB1_HPP

#include <vector>

std::vector<unsigned int> generate_list(unsigned int count, bool shuffle=true, bool reverse=false);

void partial_shuffle(std::vector<unsigned int>& input, unsigned int swapsToPerform);

template<typename Iterator>
bool in_order(const Iterator begin, const Iterator end) {
    if ( begin == end ){
        return true;
    }

    auto prev = *begin;
    for( auto itr = begin; itr < end; ++itr) {
        auto val = *itr;
        if ( val < prev ){
            return false;
        }
        prev = val;
    }

    return true;
}

void bubble_sort(std::vector<unsigned int>& input);

// for part 2
void insertion_sort(std::vector<unsigned int>& input);
void selection_sort(std::vector<unsigned int>& input);
void merge_sort(std::vector<unsigned int>& input);

#endif //COMP290_WORKSHEETS_LAB1_HPP
